import java.util.Iterator;
import java.util.HashMap;
import java.util.Map;
import java.util.Stack;

/** Limited PostScript interpreter.

   Morgan McGuire
   <br>morgan@cs.williams.edu */
public class PS {

    /** Used by pushIdentifier() to convert operator names into the actual operators. */
    public Map<Identifier, Operator>  operatorTable = new HashMap<Identifier, Operator>();
        
    public PS() {
        loadOperators();
    }

    private void loadOperators() {
        assert operatorTable.size() == 0 : "Operator table is already initialized";
        
        Operator[] opArray = 
            {new AddOperator(), new SubOperator(), new MulOperator(), new DivOperator(),
             new DefOperator(), new DupOperator(), new GtOperator(),  new NeOperator(),
             new EqOperator(),  new LtOperator(),  new IfOperator(),  new ExecOperator(),
             new ClearOperator(), new IfElseOperator(), new ExchOperator(), 
             new PopOperator(),   new PTableOperator(), new PStackOperator(),  
             new QuitOperator()};

        for (int i = 0; i < opArray.length; ++i) {
            Operator op = opArray[i];
            operatorTable.put(op.getName(), op);
        }
    }

    public int count() {}

    public Object pop() {}
    
    /** Place a value on the operand stack or execute a command. If
        the value is a variable that references a procedure, the
        procedure will be executed.  If the value is a procedure that
        procedure will be put on the operand stack as a value.*/
    public void push(Object value) { }

    private void pushIdentifier(Identifier id) { }

    public void exec(Object value) { }

    public void def(Identifier var, Object val) { }

    public void ptable() { }

    public void pstack() { }
    
    /** Read input from stdin and process it through a PS instance. */
    static public void main(String[] arg) {
    }
}
